<template>
    <Form ref="form" v-slot="{ handleSubmit, values, meta }" :initialValues="initialValues">
         <div class="v-chart-account-form px-[40px] py-[30px]">
            <div class="grid gap-4 mb-4 md:grid-cols-2">
                <div>
                    <Field name="startDate" v-slot="{ value, handleChange, errorMessage }" rules="required">
                        <label class="block mb-4 text-sm font-medium text-gray-900">Start Date<span class="sign">*</span>
                            <el-form-item :error="errorMessage">
                                <el-date-picker :model-value="value" @update:model-value="handleChange" class="mt-2"
                                    size="large" style="width: 100%" type="date" placeholder="Select Start Date"
                                    value-format="YYYY-MM-DD" format="DD/MM/YYYY" />
                            </el-form-item>
                        </label>
                    </Field>
                </div>
                <div>
                    <Field name="companyId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">Reference No <span
                                class="sign">*</span>
                            <el-form-item :error="errorMessage">
                                <el-select :model-value="value" @update:model-value="handleChange" filterable
                                class="w-[100%] mt-2" placeholder="Select a Reference" size="large" clearable>
                                <el-option v-for="(item, i) in [                                      
                                    { name: 'LHP-0001', value: 'LHP-0001' },
                                    { name: 'LHP-0002', value: 'LHP-0002' },
                                    { name: 'LHP-0003', value: 'LHP-0003' },
                                    { name: 'LHP-0004', value: 'LHP-0004' },
                                ]" :key="i" :label="item.name"
                                    :value="item.value" />
                            </el-select>
                            </el-form-item>
                        </label>
                    </Field>
                </div>
                
            </div>
          <div class="grid gap-4 mb-4 md:grid-cols-3">
            <div>
                <Field name="companyId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                    <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">ID No <span
                            class="sign">*</span>
                        <el-form-item :error="errorMessage">
                            <el-select :model-value="value" @update:model-value="handleChange" filterable
                            class="w-[100%] mt-2" placeholder="Select a id" size="large" clearable>
                            <el-option v-for="(item, i) in [                                      
                                { name: 'LHP-0001', value: 'LHP-0001' },
                                { name: 'LHP-0002', value: 'LHP-0002' },
                                { name: 'LHP-0003', value: 'LHP-0003' },
                                { name: 'LHP-0004', value: 'LHP-0004' },
                            ]" :key="i" :label="item.name"
                                :value="item.value" />
                        </el-select>
                        </el-form-item>
                    </label>
                </Field>
            </div>
            <div>
                <Field name="companyId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required">
                    <label class="block mb-2 text-sm font-medium text-gray-900" for="contractId">ID No 
                        <el-form-item :error="errorMessage">
                            <el-select :model-value="value" @update:model-value="handleChange" filterable
                              class="w-[100%] mt-2" placeholder="Select a id" size="large" clearable>
                              <el-option v-for="(item, i) in [                                      
                                  { name: 'LHP-0001', value: 'LHP-0001' },
                                  { name: 'LHP-0002', value: 'LHP-0002' },
                                  { name: 'LHP-0003', value: 'LHP-0003' },
                                  { name: 'LHP-0004', value: 'LHP-0004' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                          </el-select>
                        </el-form-item>
                    </label>
                </Field>
            </div>
            <div>
                <Field name="gender" type="checked" :value="true" :unchecked-value="false"
                    v-slot="{ value, errorMessage, handleChange }">
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                        Borrow Collateral  <span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                        <el-checkbox   :model-value="value" @update:model-value="handleChange" :disabled="isReadonly">
                            Yes
                        </el-checkbox >
                    </el-form-item>
                </Field>
            </div>


          </div>  
  
          <div class="grid gap-4 mb-4 md:grid-cols-3">
                <div>
                    <Field name="companySessionId" type="text" v-slot="{ value, errorMessage, handleChange }" rules="required"
                        :items="projects" filterable>
                        <label class="block text-sm font-medium text-gray-900">Abbreviation <span class="sign">*</span>
                            <el-form-item :error="errorMessage">
                                <el-select :model-value="value" @update:model-value="handleChange" filterable
                              class="w-[100%] mt-2" placeholder="Select a Abbreviation" size="large" clearable>
                              <el-option v-for="(item, i) in [                                      
                                  { name: 'LHP-0001', value: 'LHP-0001' },
                                  { name: 'LHP-0002', value: 'LHP-0002' },
                                  { name: 'LHP-0003', value: 'LHP-0003' },
                                  { name: 'LHP-0004', value: 'LHP-0004' },
                              ]" :key="i" :label="item.name"
                                  :value="item.value" />
                          </el-select>
                            </el-form-item>
                        </label>
                  </Field>
                </div>
                <div>
                    <Field name="fullName" type="text" v-slot="{ value, errorMessage, handleChange }" filterable rules="required">
                        <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                           Street <span class="sign">*</span></label>
                        <el-form-item :error="errorMessage">
                            <el-input :model-value="value" @update:model-value="handleChange" placeholder="Street" />
                        </el-form-item>
                    </Field>
                </div>
                <div>
                  <Field name="telegramId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      Province<span class="sign">/</span>Capital<span class="sign"> *</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="province" />
                    </el-form-item>
                  </Field>
                </div>
             </div>
  
             <div class="grid gap-4 mb-4 md:grid-cols-3">
              <div>
                <Field name="telegramId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      District<span class="sign">/</span>Khan<span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="province" />
                    </el-form-item>
                  </Field>
              </div>
              <div>
                <Field name="posId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                  <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                    Commune<span class="sign">*</span></label>
                  <el-form-item :error="errorMessage">
                    <el-input :model-value="value" @update:model-value="handleChange" placeholder="Position" />
                  </el-form-item>
                </Field>
              </div>
              <div>
                <Field name="posId" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                      Village<span class="sign">*</span></label>
                    <el-form-item :error="errorMessage">
                      <el-input :model-value="value" @update:model-value="handleChange" placeholder="Position" />
                    </el-form-item>
                  </Field>
              </div>
           </div>

           <div class="grid gap-4 mb-4 md:grid-cols-2">
            <div>
                <Field name="startDate" v-slot="{ value, handleChange, errorMessage }" rules="required">
                    <label class="block mb-4 text-sm font-medium text-gray-900">Start Date<span class="sign">*</span>
                        <el-form-item :error="errorMessage">
                            <el-date-picker :model-value="value" @update:model-value="handleChange" class="mt-2"
                                size="large" style="width: 100%" type="date" placeholder="Select Start Date"
                                value-format="YYYY-MM-DD" format="DD/MM/YYYY" />
                        </el-form-item>
                    </label>
                </Field>
            </div>
            <div>
                <Field name="remark" type="text" v-slot="{ value, errorMessage, handleChange }" filterable>
                    <label class="block mb-2 text-sm font-medium text-gray-900" :for="name">
                        Remark</label>
                    <el-form-item :error="errorMessage">
                        <el-input :model-value="value" @update:model-value="handleChange" placeholder="Remark"
                            type="textarea" />
                    </el-form-item>
                </Field>
            </div>
         </div>
         <VCollateralIfoSubTerm  />
            <div class="flex justify-center mt-5">
                <el-button v-if="!isReadonly" @click="handleSubmit($event, onSubmit(values, meta))"
                    class="bg-blue-700 hover:bg-blue-600 rounded-full ml-2 px-3 py-4 w-[100px]" size="large"
                    color="#1d4ed8">
                    Save
                </el-button>
            </div>
        </div>
    </Form>
  </template>
  <script>
  import {  ref } from "vue";
  import { Form, Field } from "vee-validate";
  import VCollateralIfoSubTerm from './VCollateralIfoSubTerm.vue';
  
  export default {
    name: 'v-mortget-agreement-form',
    components: {
        Field,
        Form,
        VCollateralIfoSubTerm,
    },
    props: {
        data: {
            type: Object,
            default: () => ({}),
        },
        isEdit: {
            type: Boolean,
            default: false,
        },
    },
  
    emits: ["submit"],
    setup(props, { emit }) {
        const form = ref();
        const initialValues = props?.data || {};
  
        const onSubmit = (values, meta) => {
            if (meta.valid) {
                emit("submit", values);
            }
        };
  
        return {
            initialValues,
            form,
            onSubmit
        }
    }
  }
  </script>